///////////////////////////////////////////////////////////////////////////////////////////////////
// (C) Carladdata GmbH 
//         MiscArgs.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////

/*! \class        MiscArgs.cpp
*  \brief        <brief description> 
*                <long description> 
*  \version      1.0 
*  \date         31.10.2006
*  \author       responsible: [kt]
*/

#include "stdafx.h"


string	MiscArgs::sm_oNotDef = "%%%UNDEF%%%";


///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibArgs::glibArgs(int nArgc, char** argv) 
*	
*   \param       (int nArgc
*   \param        char** argv
*   \return      
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
MiscArgs::MiscArgs(int nArgc, char** argv)
{
	m_oArguments.clear();
	ParseArgs(nArgc, argv);

}

//---------------------------------------------------------------------------------------------
// SECTION: 
//---------------------------------------------------------------------------------------------


///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibArgs::GetArgcount() const 
*	
*   \return      int 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
int MiscArgs::GetArgcount() const
{
	return m_nArgCount;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibArgs::HasArgument(const string& oArg) const 
*	
*   \param       const string& oArg
*   \return      bool 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
bool MiscArgs::HasArgument(const string& oArg) const
{
	return (m_oArguments.find(oArg) != m_oArguments.end());
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          string& glibArgs::GetArgument(const string& oArg) const 
*	
*   \param       const string& oArg
*   \return      const string& 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
const string& MiscArgs::GetArgument(const string& oArg) const
{
	if (m_oArguments.find(oArg) == m_oArguments.end())
		return sm_oNotDef;

	return m_oArguments.find(oArg)->second;
}



///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibArgs::ParseArgs(int nArgc, char** argv) 
*	
*   \param       (int nArgc
*   \param        char** argv
*   \return      void 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
void MiscArgs::ParseArgs(int nArgc, char** argv)
{
	m_nArgCount = 0;

	char* szCurrent = NULL;
	int nCount = 0;

	bool bHasOne = false;
	bool bInValue = false;
	string oArgument;
	string oValue;
	
	for (nCount = 1; nCount < nArgc; nCount++) {

		szCurrent = argv[nCount];

		// These cases should never happen !!
		if (szCurrent == NULL)
			continue;

		if (strlen(szCurrent) <= 0)
			continue;

		if (!bHasOne) {

			if (szCurrent[0] != '-')
				continue;
		}
		
		// Reading an argument
		if (szCurrent[0] == '-') {

			// Just a single '-' ist not an arg !! ignore it !!
			if (strlen(szCurrent) <= 1)
				continue;

			if (bHasOne) {
				if (m_oArguments.find(oArgument) == m_oArguments.end())
					m_nArgCount++;

				m_oArguments[oArgument] = oValue;

				oValue = "";
			}		

			oArgument = szCurrent;

			bInValue = false;
			bHasOne = true;
			
		}
		else {
			
			if (bInValue) {

				oValue += ' ';
				oValue += szCurrent;
			}
			else {
				oValue = szCurrent;
			}
			bInValue = true;
		}

	}

	if (bHasOne) {

		if (m_oArguments.find(oArgument) == m_oArguments.end())
			m_nArgCount++;

		m_oArguments[oArgument] = oValue;
		

	}
	

}


///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          MiscArgs::ParseArgs(const string& oArgs) 
*	
*   \param       const string& oArgs
*   \return      void 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
void MiscArgs::ParseArgs(const string& oArgs)
{
	vector<string> oArguments;

	MiscStringTokenizing::Tokenize(oArgs, " \t\n\r", oArguments);

	m_nArgCount = 0;

	const char* szCurrent;
	int nCount = 0;

	bool bHasOne = false;
	bool bInValue = false;
	string oArgument;
	string oValue;
	
	for (nCount = 0; nCount < (int)oArguments.size(); nCount++) {

		szCurrent = oArguments[nCount].c_str();

		// These cases should never happen !!
		if (szCurrent == NULL)
			continue;

		if (strlen(szCurrent) <= 0)
			continue;

		if (!bHasOne) {

			if (szCurrent[0] != '-')
				continue;
		}
		
		// Reading an argument
		if (szCurrent[0] == '-') {

			// Just a single '-' ist not an arg !! ignore it !!
			if (strlen(szCurrent) <= 1)
				continue;

			if (bHasOne) {
				if (m_oArguments.find(oArgument) == m_oArguments.end())
					m_nArgCount++;

				m_oArguments[oArgument] = oValue;

				oValue = "";
			}		

			oArgument = szCurrent;

			bInValue = false;
			bHasOne = true;
			
		}
		else {
			
			if (bInValue) {

				oValue += ' ';
				oValue += szCurrent;
			}
			else {
				oValue = szCurrent;
			}
			bInValue = true;
		}

	}

	if (bHasOne) {

		if (m_oArguments.find(oArgument) == m_oArguments.end())
			m_nArgCount++;

		m_oArguments[oArgument] = oValue;
		

	}
	

}
