

#include "stdafx.h"



bool MiscDate::DateStringToDMY(const string& oDate, int& nDay, int& nMonth, int& nYear)
{
	const char* szDate = oDate.c_str();

	nDay = 0;
	nMonth = 0;
	nYear = 0;

	int nState = 0;

	for (int nCount = 0; szDate[nCount] != 0; nCount++ )
	{
		char c = szDate[nCount];


		switch(nState) {
			case 0: /*day  */ 

				if ((c <= '9') && (c >= '0'))
				{
					nDay *= 10;
					nDay += (int)(c - '0');
				}
				else if (c == '.')
				{
					 nState = 1;
				}


				break;
			case 1: /*month*/ 

				if ((c <= '9') && (c >= '0'))
				{
					nMonth *= 10;
					nMonth += (int)(c - '0');
				}
				else if (c == '.')
				{
					 nState = 2;
				}
				break;
			case 2: /*year */ 

				if ((c <= '9') && (c >= '0'))
				{
					nYear *= 10;
					nYear += (int)(c - '0');
				}
				break;
		}
	}

	return true;
}

string MiscDate::DMYtoDateString(int nDay, int nMonth, int nYear)
{
	string oResult;

	char szBuffer[20];

	if (nYear < 100)
	{
		sprintf(szBuffer, "%02d.%02d.%02d", nDay, nMonth, nYear);
	}
	else {
		sprintf(szBuffer, "%02d.%02d.%04d", nDay, nMonth, nYear);
	}

	oResult = szBuffer;

	return oResult;
}

int MiscDate::GetDOW(int dd, int mm, int yy)
{
	const int* months = GetMonthArray(yy);
	const int* daysSoFar = GetDaySoFarArray(yy);

	if (yy < 0)
		return -1;

	if (mm > 12)
		return -1;

	if (mm < 1)
		return -1;

	if(dd > months[mm-1]) //Check If Dte Is Greater Than No. Of Days In The Month
	{
		return -1;
	}
	if (dd < 1)
		return -1;

	int ref_lp = ((yy - 1)/ 4) - ((yy - 1) / 100) + ((yy - 1) / 400); //Calculate Number Of Leap Years Till 2001

	int nDayDiff = yy * 365 + ref_lp + daysSoFar[mm - 1] + (dd - 1);

	return nDayDiff % 7;
}

void MiscDate::GetDateFromRefdate0Days(int nDays, int& dd, int& mm, int& yy)
{
	const int* months = GetMonthArray(yy);
	const int* daysSoFar = GetDaySoFarArray(yy);

	// approximate year first

	int nYearsApprox = (int)((float)(nDays ) / (365.2425f)) ; // nDays / 365.25  365,24218
											// 31556925 s / year (tropical)
	int nDaysApprox = MiscDate::GetDaysFromRefdate0(1, 1, nYearsApprox);

	// If one year less, then increase
	while((nDaysApprox + 356) < (nDays)) {
		nYearsApprox++;
		nDaysApprox = MiscDate::GetDaysFromRefdate0(1, 1, nYearsApprox);
	}

	// If year is too far, the decrease until it's fitting
	while (nDaysApprox > nDays)
	{
		nYearsApprox--;
		nDaysApprox = MiscDate::GetDaysFromRefdate0(1, 1, nYearsApprox);
		
	}

	// got the year
	yy = nYearsApprox;
	int nDaydiff = nDays - nDaysApprox;

	int nMonth = 1;



	mm = nMonth;

	// at last compute day diff since 1st of month .
	nDaysApprox = MiscDate::GetDaysFromRefdate0(1, mm, nYearsApprox);

	dd = nDays - nDaysApprox + 1;
}

int MiscDate::GetDaysFromRefdate0(int dd, int mm, int yy)
{

	const int *months = GetMonthArray(yy);
	const int* daysSoFar = GetDaySoFarArray(yy);

	if (yy < 0)
		return -1;

	if (mm > 12)
		return -1;

	if (mm < 1)
		return -1;




	if(dd > months[mm-1]) //Check If Dte Is Greater Than No. Of Days In The Month
	{
		return -1;
	}
	if (dd < 1)
		return -1;

	int ref_lp = ((yy - 1)/ 4) - ((yy - 1) / 100) + ((yy - 1) / 400); //Calculate Number Of Leap Years Till 2001

	int nDayDiff = yy * 365 + ref_lp + daysSoFar[mm - 1] + (dd - 1);

	return nDayDiff;
}

int MiscDate::ComputeCW(int dd, int mm, int yy)
{
	int dd_ = 1;
	int mm_ = 1; 
	int yy_ = yy;
	int nDOW = -1;

	// Search Monday
	while (nDOW != 0)
	{
		nDOW = GetDOW(dd_, mm_, yy_);
		dd_++;
	}

	int nDAYSRef = GetDaysFromRefdate0(dd_, mm_, yy_);
	int nDAYS = GetDaysFromRefdate0(dd, mm, yy);

	if ((nDAYS  - nDAYSRef) < 0)
		return 0;
	//1 . Erster Montag im Janjuar
	//2. Differenz der Tage / 7 + 1 = KW
	return (nDAYS  - nDAYSRef) / 7 + 1;
}


void MiscDate::DecDate(int& dd, int& mm, int& yy)
{
	const int *months = GetMonthArray(yy);

	dd--;

	if (dd < 1) {
		mm--;

		if (mm < 1) {
			mm = 12;
			yy--;
		}

		dd = months[mm-1];

	} 
}
void MiscDate::IncDate(int& dd, int& mm, int& yy)
{
	const int *months = GetMonthArray(yy);

	dd++;

	if (dd > months[mm-1]) {
		mm++;
		dd = 1;

		if (mm > 12) {
			mm = 1;
			yy++;
		}

	}
}
void MiscDate::IncDate(int& dd, int& mm, int& yy, int nDiff)
{
	int nDiff_ = nDiff;

	while(nDiff_ != 0) {

		if (nDiff_ > 0) {

			IncDate(dd,mm,yy);
			nDiff_ --;
		}

		if (nDiff_ < 0) {

			DecDate(dd,mm,yy);
			nDiff_ ++;
		}
	}
}
int MiscDate::GetDaysInMonth(int mm, int yy)
{
	const int *months = GetMonthArray(yy);

	return months[mm - 1];
}

int MiscDate::Months[] = {31,28,31,30,31,30,31,31,30,31,30,31,0};
int MiscDate::MonthsLeap[] = {31,29,31,30,31,30,31,31,30,31,30,31,0};

bool MiscDate::IsLeapYear(int yy)
{
	return (((yy % 4) == 0) &&((yy % 100) != 0)) || ((yy % 400) == 0);
}

const int* MiscDate::GetMonthArray(int yy)
{
	if (IsLeapYear(yy)) {
		return MonthsLeap;
	} else {
		return Months;
	}

}

const int* MiscDate::GetDaySoFarArray(int yy)
{
	if (IsLeapYear(yy)) {
		return DaysSoFarLeap;
	} else {
		return DaysSoFar;
	}
}
