
///////////////////////////////////////////////////////////////////////////////////////////////////
//         MiscRingbuffer.h
///////////////////////////////////////////////////////////////////////////////////////////////////

/*! \class        MiscRingbuffer.h
*  \brief        <brief description> 
*                <long description> 
*  \version      1.0 
*  \date         27.04.2011
*  \author       responsible: [kt]
*/

#ifndef _MISCRINGBUFFER_H_HEADER_INCLUDED_
#define _MISCRINGBUFFER_H_HEADER_INCLUDED_

template<class _T, int nSize_ = 300>
class MiscRingbuffer {

public:

	MiscRingbuffer()
	{
		m_nSize = nSize_;

		m_nHead = 0;
		m_nTail = 0;
	}

	MiscRingbuffer(int nSize)
	{
		m_nSize = nSize;

		m_nHead = 0;
		m_nTail = 0;
	}
	virtual ~MiscRingbuffer()
	{

	}

	MiscRingbuffer(const MiscRingbuffer& oOther)
	{
		*this = oOther;
	}
	void operator=(const MiscRingbuffer& oOther)
	{
		m_oBuf		= oOther.m_oBuf;
		m_nSize		= oOther.m_nSize;

		m_nHead		= oOther.m_nHead;
		m_nTail		= oOther.m_nTail;
	}

	void Clear(int nSize)
	{
		m_nSize = nSize;

		m_nHead = 0;
		m_nTail = 0;
		m_oBuf.clear();
	}

	void Add(const _T& oObj)
	{
		int nPos = m_nHead;

		m_nHead++;

		if (m_nHead >= m_nSize) {
			m_nHead = 0;
		}

		if (m_nHead == m_nTail)
		{
			m_nTail++;
		}

		if (m_nTail >= m_nSize) {
			m_nTail = 0;
		}

		m_oBuf[m_nHead] = oObj;

	}

	void Add(int nPos, const _T& oObj)
	{

		m_nHead++;

		if (m_nHead >= m_nSize) {
			m_nHead = 0;
		}

		if (m_nHead == m_nTail)
		{
			m_nTail++;
		}

		if (m_nTail >= m_nSize) {
			m_nTail = 0;
		}

		m_oBuf[nPos] = oObj;

		if (m_oBuf.find(nPos - m_nSize) != m_oBuf.end()) {

			m_oBuf.erase(nPos - m_nSize);

		}

	}

	const map<int,_T>& GetMap() const
	{


		return m_oBuf;
	}

	vector<_T> Get() const
	{
		vector<_T> oResult;

		for (map<int,_T>::const_iterator it =	m_oBuf.begin();
			it !=	m_oBuf.end();
			it++)
		{
			oResult.push_back(it->second);
		}

		return oResult;
	}



private:


	map<int,_T>	m_oBuf;

	int			m_nHead;
	int			m_nTail;
	int			m_nSize;


};

#endif //_MISCRINGBUFFER_H_HEADER_INCLUDED_


