

class MiscStringParsing_OptionParserIF {

public:

	virtual bool OnOption(const string& oKey) = NULL;
	virtual bool OnOption(const string& oKey, const string& oValue) = NULL;
	virtual bool OnOption(const string& oKey, const string& oValue, const vector<string>& oValues) = NULL;


};

class MiscStringParsing {

	static bool ParseOption(MiscStringParsing_OptionParserIF* pReceiver, const string& oOptionString);
	static void SetTagOpener(const string& oOpen);
	static void SetTagCloser(const string& oOpen);
	static string CreateTag(const string& oSection, int nPhraseIndex);
	static int GetTagStdLength();
	static bool AnalyseTag(const string& oTag, 
						   string& oSection, 
						   int& nPhraseIndex);

	static map<string, string> AnalyzeFeatureTag(const string& oInput);
	static string CreateFeatureTag(const map<string, string>& oFeatures);

	static string m_oTagOpenSequence;
	static string m_oTagCloseSequence;

};