
#include "stdafx.h"

bool MiscStringPath::PathDifference(const string& oBasic,
				   const string& oFull,
				   string& oDifference)
 {
 	// This is a very simple method, but hopefully it will work. we do have an URL class 
	// in the glibs kernel, but i fear this does not compile in the current state.

	int nPos =(int) oFull.find(oBasic);

	if (nPos == string::npos)
		return false;

	// Must be the leading substring (or LEFT$ to say it in BASIC words)
	if (nPos != 0)
		return false;

	string oResult = &(oFull.c_str()[oBasic.size()]);

	if ((oResult.c_str()[0] == '/') ||
		(oResult.c_str()[0] == '\\'))
	{
		string oTemp = &(oResult.c_str()[1]);
		oDifference = oTemp;
	}
	else {
		oDifference = oResult;
	}

	return true;
 }


string MiscStringPath::MergePath(const string& oPath, 
								const string& oDir)
 {
 	string oPath_ = RemoveTrailingDelimiter(oPath);
	string oDir_ = RemoveLeadingDelimiter(oDir);

#ifdef WIN32
	return (oPath_ + "\\") + oDir_;
#endif
 }


string MiscStringPath::RemoveTrailingDelimiter(const string& oDir)
 {
 	if (oDir.size() == 0)  {
		return "";
	}

	if ((oDir[oDir.size() - 1] == '\\') || 
		(oDir[oDir.size() - 1] == '/')) 
	{
		return oDir.substr(0, oDir.size() - 1);
	}
	return oDir;
 }

string MiscStringPath::RemoveLeadingDelimiter(const string& oDir)
 {
 	if (oDir.size() == 0)  {
		return "";
	}

	if ((oDir[oDir.size() - 1] == '\\') || 
		(oDir[oDir.size() - 1] == '/')) 
	{
		return oDir.substr(0, oDir.size() - 1);
	}
	return oDir;
 }

bool MiscStringPath::IsAbsolutePath(const string& oPath)
 {
 	const char* szPath = oPath.c_str();

	bool bDriveLetter = false;
	bool bColon = false;
	bool bBackslash = false;

	for (int nCount = 0; szPath[nCount] != 0; nCount++) 
	{
		const char cCharacter = szPath[nCount];

		if (MiscStringUtil::IsSpace(cCharacter))
			continue;

		if (bDriveLetter) {
			if (cCharacter == ':')  
			{
				bDriveLetter = false;
				bColon = true;
			}
			else 
				return false;
		}
		else if (bColon) {
			if ((cCharacter == '\\') || 
				(cCharacter == '/'))
			{
				bDriveLetter = false;
				bColon = true;
				return true;
			}
			else 
				return false;

		}
		else if (bBackslash){
			return true;

		}
		else {
			if ((cCharacter >= 'a') && 
				(cCharacter <= 'z')) 
			{
				bDriveLetter = true;
			}
			else if ((cCharacter >= 'A') && 
					 (cCharacter <= 'Z')) 
			{
				bDriveLetter = true;
			}
			else 
				return false;
		}
	}

	return false;
 }

string MiscStringPath::NormateDelimiter(const string& oPath, char cDelimiter)
 {
 	string oResult;

	bool bEscape = false;
	int nCount;

	for (nCount = 0; oPath.c_str()[nCount] != 0; nCount++) {

		if (!bEscape) {

			if (oPath.c_str()[nCount] == '\\') {
				bEscape = true;
			}
			else if (oPath.c_str()[nCount] == '/') 
			{
				oResult += cDelimiter;
			}
			else 
				oResult += oPath.c_str()[nCount];
		}
		else {

			switch(oPath.c_str()[nCount]) {

			case '+':
				oResult += '/';
				break;
			case '-':
				oResult += '\\';
				break;
			case '/':
			case '\\':
				oResult += cDelimiter;
				oResult += cDelimiter;
				break;
			case 'n':
			case 'r':
				oResult += '\n';
				break;
			case 't':
				oResult += '\t';
				break;
			default:
				oResult += cDelimiter;
				oResult += oPath.c_str()[nCount];
				break;
			}
			bEscape = false;
		}
	}

	if (bEscape) {
		switch(oPath.c_str()[nCount]) {

		case '+':
			oResult += '/';
			break;
		case '-':
			oResult += '\\';
			break;
		case '/':
		case '\\':
			oResult += cDelimiter;
			oResult += cDelimiter;
			break;
		case 'n':
		case 'r':
			oResult += '\n';
			break;
		case 't':
			oResult += '\t';
			break;
		default:
			oResult += cDelimiter;
			oResult += oPath.c_str()[nCount];
			break;
		}
		bEscape = false;
	}
	
	return oResult;
 }

string MiscStringPath::NormateDelimiterSimple(const string& oPath, char cDelimiter)
 {
 	string oResult;

	bool bEscape = false;
	int nCount;

	for (nCount = 0; oPath.c_str()[nCount] != 0; nCount++) {


		switch(oPath.c_str()[nCount]) {

		case '/':
			oResult += cDelimiter;
			break;
		case '\\':
			oResult += cDelimiter;
			break;
		default:
			oResult += oPath.c_str()[nCount];
			break;
		}

	}
	return oResult;
 }

string MiscStringPath::RemoveLastPathElement(const string& oPath)
 {
 	vector<string> oTokens;
	MiscStringTokenizing::Tokenize(oPath, "\\/", oTokens);

	vector<string>::iterator it_tok = oTokens.begin();

	int nTokenNo = 0;
	int nTokenCount = (int)oTokens.size();

	string oResult ;

	for (;it_tok != oTokens.end(); it_tok++, nTokenNo++) {

		string& oToken = *it_tok;

		if (nTokenNo == 0) {
			oResult = oToken;
		}
		else if (nTokenNo == nTokenCount - 1) {
			break;
		}
		else {

#ifdef WIN32
			oResult += "\\";
#endif
			oResult += oToken;
		}
	}

	return oResult;
 }
 
string MiscStringPath::RemoveFirstPathElement(const string& oPath)
 {
 	vector<string> oTokens;
	MiscStringTokenizing::Tokenize(oPath, "\\/", oTokens);

	vector<string>::iterator it_tok = oTokens.begin();

	int nTokenNo = 0;
	int nTokenCount = (int)oTokens.size();

	if (nTokenCount <= 1)
		return "";

	string oResult ;

	for (;it_tok != oTokens.end(); it_tok++, nTokenNo++) {

		string& oToken = *it_tok;

		if (nTokenNo == 1) {
			oResult = oToken;
		}
		else if (nTokenNo == 0 ) {
			continue;
		}
		else {

#ifdef WIN32
			oResult += "\\";
#endif
			oResult += oToken;
		}
	}

	return oResult;
 }

string MiscStringPath::GetLastPathElement(const string& oPath, string& oRemainingPath)
{
	vector<string> oTokens;
	MiscStringTokenizing::Tokenize(oPath, "\\/", oTokens);

	vector<string>::iterator it_tok = oTokens.begin();

	int nTokenNo = 0;
	int nTokenCount = (int)oTokens.size();

	string oResult ;
	oRemainingPath = "";

	for (;it_tok != oTokens.end(); it_tok++, nTokenNo++) {

		string& oToken = *it_tok;

		if ((nTokenNo == 0) && (oTokens.size() > 1)) {
			oRemainingPath = oToken;
		}
		else if (nTokenNo == nTokenCount - 1) {
			oResult = oToken;
			break;
		}
		else {

#ifdef WIN32
			oRemainingPath += "\\";
#endif
			oRemainingPath += oToken;
		}
	}

	return oResult;
}

