
#include "stdafx.h"

#include <boost/spirit/include/classic.hpp>
#include <boost/spirit/include/phoenix1.hpp>

#include <boost/regex.hpp>
#include <boost/regex_fwd.hpp>

using namespace std;
using namespace boost::spirit;

string MiscStringSearchReplace::Replace(	const string& oInString, 
							const string& oSearch, 
							const string& oReplace, 
							int* pSucc )
{
	string oReturn = oInString;

	if (pSucc != NULL){
		*pSucc = 0;
	}

	int nFound = (int)(oReturn.find(oSearch));

	if (nFound != string::npos)
	{
		oReturn.replace(nFound, oSearch.length(), oReplace);

		if (pSucc != NULL){
			*pSucc = 1;
		}
	}

	return oReturn;
}

string MiscStringSearchReplace::ReplaceNoCaseSense(const string& oInString, 
										  const string& oSearch, 
										  const string& oReplace, 
										  int* pSucc)
{
	string oReturn = oInString;

	string oReturn_uc = MiscStringUtil::Uppercase(oInString);
	string oSearch_uc = MiscStringUtil::Uppercase(oSearch);

	if (pSucc != NULL){
		*pSucc = 0;
	}

	int nFound = (int)(oReturn_uc.find(oSearch_uc));

	if (nFound != string::npos)
	{
		oReturn.replace(nFound, oSearch.length(), oReplace);
		oReturn_uc.replace(nFound, oSearch_uc.length(), oReplace);

		if (pSucc != NULL){
			*pSucc = 1;
		}
	}

	return oReturn;
}

string MiscStringSearchReplace::RemoveCharacters(const string& oIn, const string& oCharacters)
{
	string oOutput;
	const char* szIn = oIn.c_str();
	const char* szChars = oCharacters.c_str();

	for (int nCount = 0; szIn[nCount] != 0; nCount++)
	{

		bool bContains = false;
		for (int nInnerCount = 0; szChars[nInnerCount] != 0; nInnerCount++)
		{
			if (szIn[nCount] == szChars[nInnerCount])
				bContains = true;
		}

		if (!bContains)
			oOutput += szIn[nCount];

	}

	return oOutput;
}

//string MiscStringSearchReplace::ReloveEscapeSequence(const string& oSource)
//{
//	if (oSource.size() <= 0)
//		return "\\e";
//
//	string oRet;
//	
//	const char* szSource = oSource.c_str();
//	
//
//	for (int ncount = 0;
//		 szSource[ncount] != 0;
//		 ncount++)
//	{
//		switch(szSource[ncount]) {
//			case '\n':
//				oRet += "\\n";break;
//			case '\r':
//				oRet += "\\r";break;
//			case '\t':
//				oRet += "\\t";break;
//			case '\\':
//				oRet += "\\b";break;
//			case '\"':
//				oRet += "\\q";break;
//			case '\'':
//				oRet += "\\a";break;
//			case ';':
//				oRet += "\\c";break;
//			case ',':
//				oRet += "\\k";break;
//			case '%':
//				oRet += "\\z";break;
//			case '|':
//				oRet += "\\p";break;
//			case ' ':
//				oRet += "\\s";break;
//			case '.':
//				oRet += "\\d";break;
//			case '/':
//				oRet += "\\l";break;
//			default:
//				oRet += szSource[ncount];break;
//		}
//	}
//	return oRet;
//
//}

string MiscStringSearchReplace::ReloveEscapeSequence(const string& oSource)
{
	string oRet;
	bool bEsc = false;
	const char* szSource = oSource.c_str();
	

	for (int ncount = 0;
		 szSource[ncount] != 0;
		 ncount++)
	{
		if (bEsc) {

			switch(szSource[ncount]) {

			case 'n':
				oRet += "\n";
				break;
			case 'r':
				oRet += "\r";
				break;
			case 't':
				oRet += "\t";
				break;
			case '0':
				oRet += "\0";
				break;
			case '\\':
				oRet += "\\";
				break;
			case '\"':
				oRet += "\"";
				break;
			case '\'':
				oRet += "\'";
				break;
			case 'c':
				oRet += ";";
				break;
			case 'k':
				oRet += ",";
				break;
			case '%':
				oRet += "%";
				break;
			case 'p':
				oRet += "|";
				break;
			case 's':
				oRet += " ";
				break;
			case 'd':
				oRet += ".";
				break;
			case 'l':
				oRet += "/";
				break;
			case 'b':
				oRet += "\\";
				break;
			case 'e':
				oRet += "";
				break;
			case 'z':
				oRet += "%";
				break;
			case 'q':
				oRet += "\"";
				break;
			case 'a':
				oRet += "\'";
				break;


			default:
				oRet += "\\";
				oRet += szSource[ncount];

			}
			bEsc = false;

		}
		else {

			if(szSource[ncount]	=='\\') {
				bEsc = true;
			}
			else {
				oRet += szSource[ncount];
			}

		}
	}

	return oRet;
}

string MiscStringSearchReplace::RawSequenceToExcaped(const string& oSource)
{
	if (oSource.size() <= 0)
		return "\\e";

	string oRet;
	
	const char* szSource = oSource.c_str();
	

	for (int ncount = 0;
		 szSource[ncount] != 0;
		 ncount++)
	{
		switch(szSource[ncount]) {
			case '\n':
				oRet += "\\n";break;
			case '\r':
				oRet += "\\r";break;
			case '\t':
				oRet += "\\t";break;
			case '\\':
				oRet += "\\b";break;
			case '\"':
				oRet += "\\q";break;
			case '\'':
				oRet += "\\a";break;
			case ';':
				oRet += "\\c";break;
			case ',':
				oRet += "\\k";break;
			case '%':
				oRet += "\\z";break;
			case '|':
				oRet += "\\p";break;
			case ' ':
				oRet += "\\s";break;
			case '.':
				oRet += "\\d";break;
			case '/':
				oRet += "\\l";break;
			default:
				oRet += szSource[ncount];break;
		}
	}
	return oRet;
}


#define ReloveEscapeSequenceExtended_IncTarget		nTargetCount++; if (nTargetCount >= nResultCapacity) return nTargetCount;


int MiscStringSearchReplace::ReloveEscapeSequenceExtended(const string& oSource, 
												 unsigned char* szResult, 
												 int nResultCapacity,
												 map<int, string>& oCmdsFound, 
												 int& nVarCharactersSize,
												 int& nFirstVarCharacter)
{


	//
	//	Characters below 0x20:
	//
	// First 32 characters of ASCII encoding can be inserted with
	// \a(bel)
	//
	// NUL 00
	// SOH 01
	// STX 02
	// ETX 03
	// WOT 04
	// ENQ 05
	// ACK 06
	// BEL 07
	// BS  08
	// HT  09
	// LF  0a
	// VT  0b
	// FF  0c
	// CR  0d
	// SO  0e
	// SI  0f
	// DLE 10
	// DC1 11
	// DC2 12
	// DC3 13
	// DC4 14
	// NAK 15
	// SYN 16
	// ETB 17
	// CAN 18
	// EM  19
	// SUB 1a
	// ESC 1b
	// FS  1c
	// GS  1d
	// RS  1e
	// US  1f
	//
	//	Escape sequences:
	//
	// \\			-> \ 	
	// \"			-> "
	// \'			-> '
	// \n			-> newline
	// \r			-> return
	// \t			-> tab
	// \0			-> NUL
	// \e			-> escape
	// \a(name)		-> character below 0x20, by name
	// \c(code)		-> character by numeric code
	// \@			-> @
	//
	//	Parameters:
	//
	// @(name)		-> awaiting command with specified name
	//

	bool bEsc = false;
	bool bAwaitCharCode = false;
	bool bAwaitName = false;
	bool bAwaitParam = false;
	bool bAwaitBuffer = false;

	bool bBraceAwait = false;
	bool bInBrace = false;

	string oparam;
	const char* szSource = oSource.c_str();
	
	nVarCharactersSize = -1;
	nFirstVarCharacter = -1;

	int nTargetCount = 0;
	for (int ncount = 0;
		 szSource[ncount] != 0;
		 ncount++)
	{

		if (bInBrace) {
			if (szSource[ncount] == ')')
			{
				bBraceAwait = false;
				bool bDummy;

				if(bAwaitCharCode)
				{
					int nCharCode = MiscStringNumeric::StringToInt(oparam, bDummy);

					szResult[nTargetCount] = (unsigned char)nCharCode;
					ReloveEscapeSequenceExtended_IncTarget;
				}
				else if(bAwaitName) {
					string oUpper = MiscStringUtil::Uppercase(oparam);
					unsigned char ucCharacter = 0xff;

					// NUL 00
					if (oUpper == "NUL") {
						ucCharacter = 0x00;
					}
					// SOH 01
					else if (oUpper == "SOH") {
						ucCharacter = 0x01;
					} 
					// STX 02
					else if (oUpper == "STX") {
						ucCharacter = 0x02;
					} 
					// ETX 03
					else if (oUpper == "ETX") {
						ucCharacter = 0x03;
					} 
					// WOT 04
					else if (oUpper == "WOT") {
						ucCharacter = 0x04;
					} 
					// ENQ 05
					else if (oUpper == "ENQ") {
						ucCharacter = 0x05;
					} 
					// ACK 06
					else if (oUpper == "ACK") {
						ucCharacter = 0x06;
					} 					
					// BEL 07
					else if (oUpper == "BEL") {
						ucCharacter = 0x07;
					} 
					// BS  08
					else if (oUpper == "BS") {
						ucCharacter = 0x08;
					}
					// HT  09
					else if (oUpper == "HT") {
						ucCharacter = 0x09;
					}
					// LF  0a
					else if (oUpper == "LF") {
						ucCharacter = 0x0a;
					}
					// VT  0b
					else if (oUpper == "VT") {
						ucCharacter = 0x0b;
					}
					// FF  0c
					else if (oUpper == "FF") {
						ucCharacter = 0x0c;
					}
					// CR  0d
					else if (oUpper == "CR") {
						ucCharacter = 0x0d;
					}
					// SO  0e
					else if (oUpper == "SO") {
						ucCharacter = 0x0e;
					}
					// SI  0f
					else if (oUpper == "SI") {
						ucCharacter = 0x0f;
					}
					// DLE 10
					else if (oUpper == "DLE") {
						ucCharacter = 0x10;
					}
					// DC1 11
					else if (oUpper == "DC1") {
						ucCharacter = 0x11;
					}
					// DC2 12
					else if (oUpper == "DC2") {
						ucCharacter = 0x12;
					}
					// DC3 13
					else if (oUpper == "DC3") {
						ucCharacter = 0x13;
					}
					// DC4 14
					else if (oUpper == "DC4") {
						ucCharacter = 0x14;
					}
					// NAK 15
					else if (oUpper == "NAK") {
						ucCharacter = 0x15;
					}
					// SYN 16
					else if (oUpper == "SYN") {
						ucCharacter = 0x16;
					}
					// ETB 17
					else if (oUpper == "ETB") {
						ucCharacter = 0x17;
					}
					// CAN 18
					else if (oUpper == "CAN") {
						ucCharacter = 0x18;
					}
					// EM  19
					else if (oUpper == "EM") {
						ucCharacter = 0x19;
					}
					// SUB 1a
					else if (oUpper == "SUB") {
						ucCharacter = 0x1a;
					}
					// ESC 1b
					else if (oUpper == "ESC") {
						ucCharacter = 0x1b;
					}
					// FS  1c
					else if (oUpper == "FS") {
						ucCharacter = 0x1c;
					}
					// GS  1d
					else if (oUpper == "GS") {
						ucCharacter = 0x1d;
					}
					// RS  1e
					else if (oUpper == "RS") {
						ucCharacter = 0x1e;
					}
					// US  1f
					else if (oUpper == "US") {
						ucCharacter = 0x1f;
					}

					if (ucCharacter < 0x20)
					{
						szResult[nTargetCount] = (unsigned char)ucCharacter;
						ReloveEscapeSequenceExtended_IncTarget;
					}
				}
				else if(bAwaitParam) {
					// Mark with 0x01 to indicate that we are awaiting a parameter at 
					// this place
					szResult[nTargetCount] = 0x01;
					// store parameter name and position in out buffer
					oCmdsFound[nTargetCount] = oparam;

					// Save Increment target count (avoid buffer overrun)
					ReloveEscapeSequenceExtended_IncTarget;


				}
				else if (bAwaitBuffer)
				{
					szResult[nTargetCount] = 0x02;

					nVarCharactersSize = MiscStringNumeric::StringToInt(oparam.c_str(), bDummy);
					nFirstVarCharacter = nTargetCount;

					ReloveEscapeSequenceExtended_IncTarget;
				}
				bInBrace = false;
				bAwaitParam = false;
				bAwaitName = false;
				bAwaitCharCode = false;
				bAwaitBuffer = false;
			}
			else  {
				oparam += szSource[ncount];
			}

		}
		else if (bBraceAwait) {
			if (szSource[ncount] == '(')
			{
				bBraceAwait = false;
				bInBrace = true;
				oparam = "";
			}
		}
		else if (bEsc) {

			switch(szSource[ncount]) {

			case 'n':
			case 'N':
				szResult[nTargetCount] = '\n';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case 'r':
			case 'R':
				szResult[nTargetCount] = '\r';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case 't':
			case 'T':
				szResult[nTargetCount] = '\t';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '0':
				szResult[nTargetCount] = '\0';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '\\':
				szResult[nTargetCount] = '\\';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '\"':
				szResult[nTargetCount] = '\"';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '\'':
				szResult[nTargetCount] = '\'';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '@':
				szResult[nTargetCount] = '@';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case '#':
				szResult[nTargetCount] = '#';
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			case 'a':
			case 'A':
				bBraceAwait = true;
				bAwaitName = true;
				break;
			case 'c':
			case 'C':
				bBraceAwait = true;
				bAwaitCharCode = true;
				break;
			case 'e':
			case 'E':
				// Escape
				szResult[nTargetCount] = 0x1b;
				ReloveEscapeSequenceExtended_IncTarget;
				break;
			default:
				szResult[nTargetCount] = '\\';
				ReloveEscapeSequenceExtended_IncTarget;
				szResult[nTargetCount] = szSource[ncount];
				ReloveEscapeSequenceExtended_IncTarget;

			}
			bEsc = false;

		}
		else {

			if(szSource[ncount]	== '\\') {
				bEsc = true;
			}
			else if(szSource[ncount]	== '@') {
				bBraceAwait = true;
				bAwaitParam = true;
			}
			else if(szSource[ncount]	== '#') {
				bBraceAwait = true;
				bAwaitBuffer = true;
			}
			else {
				szResult[nTargetCount] = szSource[ncount];
				ReloveEscapeSequenceExtended_IncTarget;
			}

		}
	}

	return nTargetCount;
}

enum MiscStringUtil_MakeRX_State {

	MiscStringUtil_MakeRX_State_Base,
	MiscStringUtil_MakeRX_State_Esc,
	MiscStringUtil_MakeRX_State_H0,
	MiscStringUtil_MakeRX_State_H1

};

string MiscStringSearchReplace::SearchstringToRegex(const string& oMaskString, bool& bError)
{
	string oResult;
	string oPostfix = "";




	MiscStringUtil_MakeRX_State eParseState = MiscStringUtil_MakeRX_State_Base;

	const char* szIn = oMaskString.c_str();
	int nHexVal = 0;

	for (int nCount = 0; szIn[nCount] != 0; nCount++)
	{
		bool bCharFound = false;
		char cInChar = szIn[nCount];

		if ((cInChar == '\\') && (eParseState == MiscStringUtil_MakeRX_State_Base))
		{
			eParseState = MiscStringUtil_MakeRX_State_Esc;
			continue;
		}

		//Bei Wildcard Suchen:
		//  ToStringOperators_FindOperation_Wildcard
		//	ToStringOperators_FindOperation_Mask
		//	ToStringOperators_FindOperation_Exact
		//
		//			WC/SW							MSK							SONST
		//	*		"[[:alnum:]| |[:punct:]]*"		"[[:alnum:]|[:punct:]]*"	"\\*"
		//	?		"[[:alnum:]| |[:punct:]]"		"[[:alnum:]]+"				"\\?"
		//	#		"[[:digit:]]+"					"[[:digit:]]"				"\\#"
		//	@		"[[:alpha:]]+"					"[[:digit:]]+"				"\\@"
		//	& 		-								"[[:alpha:]]"				"\\&"
		//			-								"[[:alpha:]]+"				"\\"
		//	\w		"[[:space:]]+"					"[[:space:]]+"				"w"
		//	\v		"[[:space:]]*"					"[[:space:]]*"				"v"
		//	\x		^								^							"x"	
		//	\y		$								$							"y"		

		switch(eParseState)
		{
		case MiscStringUtil_MakeRX_State_Base:
			//			WC/SW							MSK							SONST
			//	*		"[[:alnum:]| |[:punct:]]*"		"[[:alnum:]|[:punct:]]*"	"\\*"
			//	?		"[[:alnum:]| |[:punct:]]"		"[[:alnum:]]+"				"\\?"
			//	#		"[[:digit:]]+"					"[[:digit:]]"				"\\#"
			//	@		"[[:alpha:]]+"					"[[:digit:]]+"				"\\@"
			//	& 		-								"[[:alpha:]]"				"\\&"
			//			-								"[[:alpha:]]+"				"\\"

			switch(cInChar) {
			case '~': oResult = oResult + "[[:digit:]]+[[\\,\\.]?[[:digit:]]*]?";		bCharFound = true; break;
			case '*': oResult = oResult + "[[:alnum:]| |[:punct:]]*";	bCharFound = true; break;
			case '?': oResult = oResult + "[[:alnum:]| |[:punct:]]";	bCharFound = true; break;
			case '#': oResult = oResult + "[[:digit:]]+";				bCharFound = true; break;
			case '@': oResult = oResult + "[[:alpha:]]+";				bCharFound = true; break;
			case '&': oResult = oResult + "[[:alpha:]]";				bCharFound = true; break;
			case '': oResult = oResult + "[[:digit:]]";				bCharFound = true; break;
			};

			if (bCharFound)
			{
				continue;
			}
		
			//Sonderzeichen:
			//	
			switch(cInChar) {
			case '[': oResult = oResult + "\\[";	bCharFound = true; break;
			case ']': oResult = oResult + "\\]";	bCharFound = true; break;
			case '(': oResult = oResult + "\\(";	bCharFound = true; break;
			case ')': oResult = oResult + "\\)";	bCharFound = true; break;
			case '{': oResult = oResult + "\\{";	bCharFound = true; break;
			case '}': oResult = oResult + "\\}";	bCharFound = true; break;
			case '*': oResult = oResult + "\\*";	bCharFound = true; break;
			case '+': oResult = oResult + "\\+";	bCharFound = true; break;
			case '-': oResult = oResult + "\\-";	bCharFound = true; break;
			case '^': oResult = oResult + "\\^";	bCharFound = true; break;
			case '|': oResult = oResult + "\\|";	bCharFound = true; break;
			case '>': oResult = oResult + "\\>";	bCharFound = true; break;
			case '<': oResult = oResult + "\\<";	bCharFound = true; break;
			case '_': oResult = oResult + "\\_";	bCharFound = true; break;
			case '=': oResult = oResult + "\\=";	bCharFound = true; break;
			case '/': oResult = oResult + "\\/";	bCharFound = true; break;
			case ',': oResult = oResult + "\\,";	bCharFound = true; break;
			case '.': oResult = oResult + "\\.";	bCharFound = true; break;
			case ';': oResult = oResult + "\\;";	bCharFound = true; break;
			case ':': oResult = oResult + "\\:";	bCharFound = true; break;
			case '': oResult = oResult + "\\";	bCharFound = true; break;
			case '`': oResult = oResult + "\\`";	bCharFound = true; break;
			case '$': oResult = oResult + "\\$";	bCharFound = true; break;
			case '!': oResult = oResult + "\\!" ;	bCharFound = true; break;
			};

			if (bCharFound)
			{
				continue;
			}



			break;
		case MiscStringUtil_MakeRX_State_Esc:

			if (cInChar == 'h')
			{
				eParseState = MiscStringUtil_MakeRX_State_H0;
				continue;
			}


			//	\w		"[[:space:]]+"					"[[:space:]]+"				"w"
			//	\v		"[[:space:]]*"					"[[:space:]]*"				"v"
			//	\x		^								^							"x"	
			//	\y		$								$							"y"	

			switch(cInChar) {
			case 'w': oResult = oResult + "[[:space:]]+";		bCharFound = true; break;
			case 'v': oResult = oResult + "[[:space:]]*";		bCharFound = true; break;
			case 'x': oResult = oResult + "^";					bCharFound = true; break;
			case 'y': oResult = oResult + "$";					bCharFound = true; break;
			};



			if (bCharFound)
			{
				eParseState = MiscStringUtil_MakeRX_State_Base;
				continue;
			}

			switch(cInChar) {
			case 'n': oResult = oResult + "\\n" ; bCharFound = true; break;
			case 'r': oResult = oResult + "\\r" ; bCharFound = true; break;
			case 't': oResult = oResult + "\\t" ; bCharFound = true; break;
			case '\0': oResult = oResult + "\0"  ; bCharFound = true; break;
			case '\\': oResult = oResult + "\\\\"; bCharFound = true; break;
			case 'z': oResult = oResult + "\\%" ; bCharFound = true; break;
			case 'p': oResult = oResult + "\\|" ; bCharFound = true; break;
			case 's': oResult = oResult + " "   ; bCharFound = true; break;
			case 'd': oResult = oResult + "\\."	; bCharFound = true; break;							
			case 'l': oResult = oResult + "\\/"	; bCharFound = true; break;							
			case 'b': oResult = oResult + "\\\\"; bCharFound = true; break;								
			case 'e': oResult = oResult + ""    ; bCharFound = true; break;
			case 'q': oResult = oResult + "\\\""; bCharFound = true; break;
			case 'a': oResult = oResult + "\\\'"; bCharFound = true; break;
			case 'c': oResult = oResult + "\\;"	; bCharFound = true; break;							
			case 'k': oResult = oResult + "\\,"	; bCharFound = true; break;							
			case 'g': oResult = oResult + "\\~"	; bCharFound = true; break;				
			case '\"': oResult = oResult + "\\\""; bCharFound = true; break;
			case '\'': oResult = oResult + "\\\'"; bCharFound = true; break;
			case '*': oResult = oResult + "\\*" ; bCharFound = true; break;
			case '#': oResult = oResult + "\\#" ; bCharFound = true; break;
			case '?': oResult = oResult + "\\?" ; bCharFound = true; break;
			case '!': oResult = oResult + "\\!" ; bCharFound = true; break;
			case '@': oResult = oResult + "\\@" ; bCharFound = true; break;
			case '': oResult = oResult + "\\" ; bCharFound = true; break;
			case '&': oResult = oResult + "\\&" ; bCharFound = true; break;
			case '[': oResult = oResult + "\\[" ; bCharFound = true; break;
			case ']': oResult = oResult + "\\]" ; bCharFound = true; break;
			case '(': oResult = oResult + "\\(" ; bCharFound = true; break;
			case ')': oResult = oResult + "\\)" ; bCharFound = true; break;
			case '{': oResult = oResult + "\\{" ; bCharFound = true; break;
			case '}': oResult = oResult + "\\}" ; bCharFound = true; break;
			case '+': oResult = oResult + "\\+" ; bCharFound = true; break;
			case '-': oResult = oResult + "\\-" ; bCharFound = true; break;
			case '^': oResult = oResult + "\\^" ; bCharFound = true; break;
			case '|': oResult = oResult + "\\|" ; bCharFound = true; break;
			case '>': oResult = oResult + "\\>" ; bCharFound = true; break;
			case '<': oResult = oResult + "\\<" ; bCharFound = true; break;
			case '_': oResult = oResult + "\\_" ; bCharFound = true; break;
			case '=': oResult = oResult + "\\=" ; bCharFound = true; break;
			case '/': oResult = oResult + "\\/" ; bCharFound = true; break;
			case ',': oResult = oResult + "\\," ; bCharFound = true; break;
			case '.': oResult = oResult + "\\." ; bCharFound = true; break;
			case ';': oResult = oResult + "\\;" ; bCharFound = true; break;
			case ':': oResult = oResult + "\\:" ; bCharFound = true; break;
			case '': oResult = oResult + "\\" ; bCharFound = true; break;
			case '`': oResult = oResult + "\\`" ; bCharFound = true; break;
			case '$': oResult = oResult + "\\$"	; bCharFound = true; break;		
			};

			eParseState = MiscStringUtil_MakeRX_State_Base;

			if (!bCharFound)
			{
				bError = true;
				continue;
			}




			break;
		case MiscStringUtil_MakeRX_State_H0:

			// State switch
			//if ((cInChar == 'h') || (cInChar == 'H'))
			//{
			//	eParseState = ToStringOperators_MakeRX_State_H0;
			//	continue;
			//}
			//break;
		case MiscStringUtil_MakeRX_State_H1:

			//	
			//Hex Escape:
			//
			//	\hdd	"\\x%02x"
			//	

			if ((cInChar >= '0') && (cInChar <= '9')) 
			{
				nHexVal = nHexVal * 16 + (int)(cInChar - '0');
			}
			else if ((cInChar >= 'a') && (cInChar <= 'f')) 
			{
				nHexVal = nHexVal * 16 + (int)(cInChar - 'a') + 10;
			}
			else if ((cInChar >= 'A') && (cInChar <= 'F')) 
			{
				nHexVal = nHexVal * 16 + (int)(cInChar - 'A') + 10;
			}
			else {
				eParseState = MiscStringUtil_MakeRX_State_Base;
				bError = true;
				nHexVal = 0;
			}


			// State switches
			if (eParseState == MiscStringUtil_MakeRX_State_H0)
			{
				eParseState = MiscStringUtil_MakeRX_State_H1;
			}
			else if (eParseState == MiscStringUtil_MakeRX_State_H1)
			{
				eParseState = MiscStringUtil_MakeRX_State_Base;

				char szBuf[30];
				sprintf(szBuf, "\\x%02x", nHexVal);
				oResult = oResult + szBuf;
				bCharFound = true;

				nHexVal = 0;

			}
			break;
		}



		if ((eParseState == MiscStringUtil_MakeRX_State_Base) && (!bCharFound)) {
			oResult = oResult + cInChar;
		}

	}

	return oResult + oPostfix;
}

int MiscStringSearchReplace::SearchWildcard(const string& oIn, const string& oSearchstring)
{


	// FIX CASE: to lowercase if NOT case sensitive


	string oIn_ = MiscStringUtil::Lowercase(oIn);
	string oSearchstring_ = MiscStringUtil::Lowercase(oSearchstring);


	// Evaluate regex and perform replace
	bool bError = false;
	string oRegexSearchstring = SearchstringToRegex(oSearchstring_, bError);

	try{
		if (!bError)
		{
			boost::regex expr;
			boost::match_results<std::string::const_iterator> what; 

			// Do a regexp match
			expr.assign(oRegexSearchstring);	
			bool bSucc = boost::regex_search(oIn_, what, expr );

			// not found return -1
			if (!bSucc)
				return -1;

			// Assign found substring to a temp string
			string::const_iterator it_from = what[0].first;
			string::const_iterator it_to = what[0].second;

			bool bMatch = what[0].matched;
			string oRes(it_from, it_to);

			// and find out position in imput string
			int nFindRes = oIn_.find(oRes);

			// return position or -1 for not found.
			if (nFindRes == string::npos)
				return -1;
			return nFindRes;

		}
		else  
		{
			// TODO: [kt] 30.07.2010
			return -1;
		}
	}
	catch(...)
	{
		return -1;
	}

	return -1;

}