
#include "stdafx.h"

int MiscStringTokenizing::Tokenize(const string& oSource, const char* szDelimiters, vector<string>& oTokens)
{
	MiscStringTokenizer<char> oTokenizer;

	oTokenizer.Set(oSource);

	while (oTokenizer.NextToken(szDelimiters)) {

		string oResult = oTokenizer.GetResult();

		oTokens.push_back(oResult);
	}

	return (int)oTokens.size();
}

int MiscStringTokenizing::Tokenize(const string& oSource, const char* szDelimiters, set<string>& oTokens)
{
	MiscStringTokenizer<char> oTokenizer;

	oTokenizer.Set(oSource);

	while (oTokenizer.NextToken(szDelimiters)) {

		string oResult = oTokenizer.GetResult();

		oTokens.insert(oResult);
	}

	return (int)oTokens.size();
}

int MiscStringTokenizing::QuoteTokenize(const string& oSource, const char* szDelimiters, vector<string>& oTokens)
{
	MiscStringQuoteTokenizer<char> oTokenizer;

	if (strlen(szDelimiters) == 0)
		return 0;

	oTokenizer.Set(oSource + szDelimiters[0]);

	while (oTokenizer.NextToken(szDelimiters, "\"\'")) {

		string oResult = oTokenizer.GetResult();

		oTokens.push_back(oResult);
	}

	return (int)oTokens.size();
}

int MiscStringTokenizing::StrictTokenize(const string& oSource, const char* szDelimiters, vector<string>& oTokens)
{
	MiscStringStrictTokenizer<char> oTokenizer;

	oTokenizer.Set(oSource);

	while (oTokenizer.NextToken(szDelimiters)) {

		string oResult = oTokenizer.GetResult();

		oTokens.push_back(oResult);
	}

	return (int)oTokens.size();
}

int MiscStringTokenizing::Tokenize(const ucString& oSource, 
									const short* szDelimiters, 
									vector<ucString>& oTokens)
{
	MiscStringTokenizer<short> oTokenizer;

	oTokenizer.Set(oSource);

	while (oTokenizer.NextToken(szDelimiters)) {

		basic_string<short> oResult = oTokenizer.GetResult();

		oTokens.push_back(oResult);
	}

	return (int)oTokens.size();
}