
#include "stdafx.h"

	// Basic string functions
string MiscStringUtil::TrimString(const string& oSrc)
{
	string oResult;
	const char* String = oSrc.c_str();

	int nCount = 0;
	int nFrom = -1;
	int nTo = -1;

	for (nCount = 0; String[nCount] != 0; nCount++) {

		if (!IsSpace(String[nCount] )) 
		{
			if (nFrom < 0)
				nFrom = nCount;

			nTo = nCount;
		}
		if (nFrom >= 0) {
			oResult += String[nCount];
		}

	}

	if (nTo < 0)
		return "";

	string oEndResult;

	nFrom = -1;
	nTo = -1;

	for (nCount = (int)oResult.length() - 1;
		 nCount >=0;
		 nCount--)

	{
		if (!IsSpace(oResult[nCount] )) 
		{
			if (nTo < 0)
				nTo = nCount;

			nFrom = nCount;
		}
		if (nTo >= 0) {
			oEndResult = oResult[nCount] + oEndResult;
		}
	}

	// Terminate
	/*if ((nTo + 1) < (int)oResult.length())
		oResult.at(nTo + 1) = 0;*/


	// The result string might be messed up due raw termination, so we return a c-string and let the
	// constructor do the re-initialization
	return oEndResult;
}

string MiscStringUtil::TrimUppercaseString(const string& oStr)
{
	string oResult;
	

	const char* String = oStr.c_str();

	int nCount = 0;
	int nFrom = -1;
	int nTo = -1;

	for (nCount = 0; String[nCount] != 0; nCount++) {

		if (!IsSpace(String[nCount] )) 
		{
			if (nFrom < 0)
				nFrom = nCount;

			nTo = nCount;
		}
		if (nFrom >= 0) {
			oResult += String[nCount];
		}

	}

	if (nTo < 0)
		return "";

	string oEndResult;

	nFrom = -1;
	nTo = -1;


	for (nCount = (int)oResult.length() - 1;
		 nCount >=0;
		 nCount--)

	{
		if (!IsSpace(oResult[nCount] )) 
		{
			if (nTo < 0)
				nTo = nCount;

			nFrom = nCount;
		}
		if (nTo >= 0) {

			if ((oResult[nCount] >= 'a') && 
				(oResult[nCount] <= 'z'))
			{
				oEndResult = (char)(oResult[nCount] - 'a' + 'A' ) + oEndResult;
			}
			else if (oResult[nCount] == '')
			{
				oEndResult = string("") + oEndResult;
			}
			else if (oResult[nCount] == '')
			{
				oEndResult = string("") + oEndResult;
			}
			else if (oResult[nCount] == '')
			{
				oEndResult = string("") + oEndResult;
			}
			else  {
				oEndResult = oResult[nCount]  + oEndResult;
			}
			
		}
	}

	// Terminate
	/*if ((nTo + 1) < (int)oResult.length())
		oResult.at(nTo + 1) = 0;*/


	// The result string might be messed up due raw termination, so we return a c-string and let the
	// constructor do the re-initialization
	return oEndResult;
}

string MiscStringUtil::Leftstring(const string& oSource, int nPos)
{
	string oResult;

	for (int nCount = 0; 
		 (nCount < nPos) && (oSource.c_str()[nCount] != 0);
		 nCount++)
	{
		oResult += oSource.c_str()[nCount];
	}

	return oResult;
}

string MiscStringUtil::Rightstring(const string& oSource, int nPos)
{
	return &(oSource.c_str()[nPos]);
}

string MiscStringUtil::UppercaseSpecial(const string& oKey)
{
	string oResult;
	const char* szSource = oKey.c_str();


	int nCount = 0;
	for (;
		 szSource[nCount] != 0;
		 nCount++)
	{
		if ((szSource[nCount] >= 'a') && 
			(szSource[nCount] <= 'z'))
		{
			oResult += szSource[nCount] - 'a' + 'A';
		}
		else if ((szSource[nCount] >= '0') && 
				 (szSource[nCount] <= '9'))
		{
			oResult += szSource[nCount];
		}
		else if ((szSource[nCount] >= 'A') && 
				 (szSource[nCount] <= 'Z'))
		{
			oResult += szSource[nCount];
		}
		else if ((szSource[nCount] == '_') || 
				 (szSource[nCount] == '-'))
		{
			oResult += szSource[nCount];
		}

	}

	return oResult;
}

string MiscStringUtil::Uppercase(const string& oInString)
{
	string oResult;
	const char* szSource = oInString.c_str();


	int nCount = 0;
	for (;
		 szSource[nCount] != 0;
		 nCount++)
	{
		if ((szSource[nCount] >= 'a') && 
			(szSource[nCount] <= 'z'))
		{
			oResult += szSource[nCount] - 'a' + 'A';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else 
		{
			oResult += szSource[nCount];
		}

	}

	return oResult;
}

string MiscStringUtil::Lowercase(const string& oInString)
{
	string oResult;
	const char* szSource = oInString.c_str();


	int nCount = 0;
	for (;
		 szSource[nCount] != 0;
		 nCount++)
	{
		if ((szSource[nCount] >= 'A') && 
			(szSource[nCount] <= 'Z'))
		{
			oResult += szSource[nCount] - 'A' + 'a';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else if (szSource[nCount] == '') {
			oResult += '';
		}
		else 
		{
			oResult += szSource[nCount];
		}

	}

	return oResult;
}

string MiscStringUtil::FmtString(const char* szFmt, ...)
{
	va_list vaArgumentList;


	char szBuffer[32768];

	va_start(vaArgumentList, szFmt);
	_vsnprintf( szBuffer, sizeof(szBuffer), szFmt, vaArgumentList);
	va_end(vaArgumentList);	


	return szBuffer;
}

bool MiscStringUtil::IsSpace(const char cCharacter)
{
	if ((cCharacter == ' ') ||
		(cCharacter == '\t') ||
		(cCharacter == '\n') ||
		(cCharacter == '\r'))
		return true;
	return false;
}

bool MiscStringUtil::IsSpace(const short cCharacter)
{
	if ((cCharacter == (short)' ') ||
		(cCharacter == (short)'\t') ||
		(cCharacter == (short)'\n') ||
		(cCharacter == (short)'\r'))
		return true;
	return false;
}

bool MiscStringUtil::IsIn(const char* szString, char cCharacter)
{
	for (int nCount = 0;
		 szString[nCount] != 0;
		 nCount++)
	{
		if (szString[nCount] == cCharacter)
			return true;
	}
	return false;
}

	// Tabbifier
string MiscStringUtil::NormateTabsAtLinestart(const string& oSource, int nTabcount)
{
	string oResult;
	vector<string> oLines;

	MiscStringTokenizing::Tokenize(oSource, "\n\r", oLines);

	int nCount = 0;
	for (vector<string>::iterator it = oLines.begin();
		 it != oLines.end();
		 it++, nCount++)
	{
		oResult += MakeTabs('\t', nTabcount) + TrimString(*it) + ((nCount == (oLines.size() -1))?(""):("\r"));
	}

	return oResult;
}

string MiscStringUtil::MakeTabs(char cTabChar, int nCount)
{
	string oResult;

	for (int nCount_ = 0; nCount_ < nCount; nCount_++) {

		oResult += cTabChar;

	}

	return oResult;
}

// Special string functions
string MiscStringUtil::ReduceToValidCharacters(const string& oSource, 
											const char* szValid)
{
	const char* szSource = oSource.c_str();
	string oResult;

	for (int nCount = 0;
		szSource[nCount] != 0;
		nCount++)
	{
		if (IsIn(szValid, szSource[nCount]))
			oResult += szSource[nCount];
	}

	return oResult;
}
string MiscStringUtil::EliminateDirective(const char* szSource)
{
	int nCount = 0;

	// Wait for '@'
	for (;szSource[nCount] != '@'; nCount++) {
		if (szSource[nCount] == 0)
			return szSource;
	}

	// Wait for ':'
	for (;szSource[nCount] != ':'; nCount++) {
		if (szSource[nCount] == 0)
			return szSource;
	}

	return &(szSource[nCount + 1]);
}

string MiscStringUtil::Substitute(const string& oSource, const string& oPatter, const string& Substitution)
{
	string oTemp = oSource;

	int nFoundAt = (int)oTemp.find(oPatter);

	while (nFoundAt != string::npos)
	{
		string oTempTemp = MiscStringUtil::Leftstring(oTemp, nFoundAt) + 
						   Substitution +
						   MiscStringUtil::Rightstring(oTemp, nFoundAt + (int)oPatter.size());

		oTemp = oTempTemp;

		nFoundAt = (int)oTemp.find(oPatter);
	}

	return oTemp;
}
