


template<class _CharacterType>
class MiscStringTokenizer {

public:
	
	MiscStringTokenizer()
	{
		Reset();
	}
	MiscStringTokenizer(const _CharacterType* szString)
	{
		Set(szString);
	}
	MiscStringTokenizer(const basic_string<_CharacterType>& oString)
	{
		Set(oString);
	}

	void Set(const _CharacterType* szString)
	{
		Reset();
		basic_string<_CharacterType> oString = szString;
		Set(oString);
	}
	void Set(const basic_string<_CharacterType>& oString)
	{
		Reset();
		m_oBasicString = oString;
	}

	void Reset()
	{
		ResetPositions();
	}

	bool NextToken(const _CharacterType* szDelimiters)
	{
		if (m_nCurrentPosition_From < 0) {
			m_nCurrentPosition_From = 0;
			m_nCurrentPosition_To = 0;
		}

		m_nCurrentPosition_From = m_nCurrentPosition_To;

		const _CharacterType* szOriginalString = m_oBasicString.c_str();

		while (szOriginalString[m_nCurrentPosition_To] != ((_CharacterType)0))
		{
			if (IsDelimiter(szOriginalString[m_nCurrentPosition_To], szDelimiters))
			{
				if (m_nCurrentPosition_To > m_nCurrentPosition_From) {
					m_oResult = m_oBasicString.substr(m_nCurrentPosition_From,
													  m_nCurrentPosition_To - m_nCurrentPosition_From);

					return true;
				}
			}

			m_nCurrentPosition_To++;
			if (IsDelimiter(szOriginalString[m_nCurrentPosition_From], szDelimiters)) {
				m_nCurrentPosition_From++;
			}
		}

		if (m_nCurrentPosition_To == m_nCurrentPosition_From) {
			m_oResult.clear();// = (const _CharacterType*)L"";
			return false;
		}

		m_oResult = m_oBasicString.substr(m_nCurrentPosition_From,
										  m_nCurrentPosition_To - m_nCurrentPosition_From);

		return true;

	}
	bool NextToken(const basic_string<_CharacterType> oDelimiters)
	{
		bool bSucc = NextToken(oDelimiters.c_str());
	}

	const basic_string<_CharacterType>& GetResult() const {

		return m_oResult;
		
	}

	const _CharacterType* GetStrResult() const {

		return m_oResult.c_str();
		
	}


private:

	void ResetPositions() {
		m_nCurrentPosition_From = -1;
		m_nCurrentPosition_To = -1;
	}

	bool IsDelimiter(const _CharacterType szCharacter, const _CharacterType* szDelimiters) {

		for (int nCount = 0; szDelimiters[nCount] != (_CharacterType)0; nCount++) {

			if (szCharacter == szDelimiters[nCount]) 
				return true;

		}

		return false;
	}

	basic_string<_CharacterType>	m_oBasicString;
	basic_string<_CharacterType>	m_oResult;

	int								m_nCurrentPosition_From;
	int								m_nCurrentPosition_To;

};
